# $Date: 1995/08/25 19:01:08 $ $Author: kg $ $Revision: 1.8 $
#
#++
Cat::GcdDomain -- the category of integral domains with a gcd

A Cat::GcdDomain is an Cat::IntegralDomain with a gcd. The axioms for the gcd are:
i)	divex(x, gcd(x,y)) <> FAIL
ii)	divex(y, gcd(x,y)) <> FAIL
iii)	divex(x,z) <> FAIL and divex(y,z) <> FAIL =>
		divex(z, gcd(x,y)) <> FAIL
iv)	Ax::canonicalUnitNormal => gcd(x,y) = gcd(y,x)

Methods:
gcd(x1,x2,...) - returns the gcd of x1,x2,...
lcm(x1,x2,...) - returns the lcm of x1,x2,...
++#

Cat::GcdDomain:= CategoryConstructor(
    Cat::GcdDomain,
    [],
    [],
    NIL,
    [ Cat::IntegralDomain ],
    [],

    "gcd",

    "lcm" = proc(x,y) begin
	case args(0)
	of 2 do break;
	of 1 do return(this::gcd(x));
	of 0 do return(this::one);
	otherwise y:= this::lcm(args(2..args(0)));
	end_case;
	this::_mult(x, this::divex(y, this::gcd(x, y)))
    end_proc

)():

